import { Loader, OrbitControls, useGLTF } from '@react-three/drei';
import { Canvas } from '@react-three/fiber';
import { EffectComposer, Outline, Select, Selection } from '@react-three/postprocessing';
import { KernelSize } from 'postprocessing';
import { Suspense, useEffect, useRef } from 'react';
import { Box2, MeshNormalMaterial } from 'three';
import './button.css';
// import { OrbitControls } from '@react-three/deri';

interface ButtonProps {
  /**
   * Is this the principal call to action on the page?
   */
  primary?: boolean;
  /**
   * What background color to use
   */
  backgroundColor?: string;
  /**
   * How large should the button be?
   */
  size?: 'small' | 'medium' | 'large';
  /**
   * Button contents
   */
  label: string;
  /**
   * Optional click handler
   */
  onClick?: () => void;
}

/**
 * Primary UI component for user interaction
 */
export const Viewer = ({
  primary = false,
  size = 'medium',
  backgroundColor,
  label,
  ...props
}: ButtonProps) => {
  const mode = primary ? 'storybook-button--primary' : 'storybook-button--secondary';
  console.log('render');

  const modelRef = useRef(null!)
  const modelFile = useGLTF('/scene (3).glb')
  useEffect( () => {
  }, [])

  return (
    <Canvas shadows id={'canvas'} style={{height:window.innerHeight}}>
      <OrbitControls></OrbitControls>
      <ambientLight intensity={0.8}></ambientLight>
      {/* <directionalLight castShadow intensity={0.8} position={[2, 4, 4]}></directionalLight>
        <Selection>
          <EffectComposer multisampling={2} enabled={true} autoClear={false}>
            <Outline edgeStrength={500} width={1024} blur={true} xRay={false} kernelSize={KernelSize.LARGE} />
          </EffectComposer>
          <Select enabled={true}> */}
      {/* <mesh>
        <meshNormalMaterial></meshNormalMaterial>
        <boxGeometry></boxGeometry>
      </mesh> */}

      <Suspense fallback={<Loader />}>
        <primitive object={modelFile.scene}>
          <meshNormalMaterial></meshNormalMaterial>
        </primitive>
      </Suspense>
      {/*   <
          </Select>
        </Selection> */}
    </Canvas>
  );
};
